require "player"
require 'world'
require 'enemybullets'
require 'wave'
require 'menu'

function love.load()
	game = {}
	game.state = "menu"
	game.scene = "first"
	game.mode = nil
	font = love.graphics.newFont(30)
	little = love.graphics.newFont(14)
	realittle = love.graphics.newFont(5)
	menufont = love.graphics.newFont(64)
	bulletspeed = 1200
	bframe = 0
	math.randomseed( os.time() )
	test1 = math.random()
	setSolids()
	screenwidth = love.graphics.getWidth()
	-------------------------------
	button.spawn((screenwidth - menufont:getWidth("Single Player")) /2, menufont:getHeight() * 2,"start","Single Player")
	button.spawn((screenwidth - menufont:getWidth("Multiplayer")) /2, menufont:getHeight() * 3,"multiplayer","Multiplayer")
	button.spawn(32, menufont:getHeight() * 7,"quit","Quit")
	-------------------------------
end

function love.keypressed(k)
	if game.mode == "single" or nil then
		p.move(k)
	end
	if k == "escape" then love.event.push("quit") end
end


function love.update(dt)
	if game.state == "ingame" and game.state ~= "over" then
		playerUpdates(dt)
		enemyUpdates(dt)
		bulletUpdates(dt)
		worldUpdates(dt)
	end
	if game.mode == "multi" then
		if love.keyboard.isDown(" ") or love.keyboard.isDown("return") then
			game.state = "menu"
			game.mode = nil
		end
	end
end

function love.mousepressed(x,y,buttonx)
	if buttonx == "l" then
		if game.state == "menu" then
			checkClick(x,y)
		end
	end
end

function love.draw()
	if game.state == 'ingame' and game.mode ~= 'multi' then
		eb.draw()
		world.draw()
		bullet.draw()
		p.draw()
		e.draw()
		p.drawGUI()
		wave.display()
	elseif game.state == "menu" then
		if game.scene == "first" then
			menuDraw()
			love.graphics.printf("Survive",0,32,screenwidth,"center")
		end
	elseif game.state == "over" then
		gameOver()
	end
	if game.mode == 'multi' then
		love.graphics.setFont(little)
		love.graphics.clear()
		love.graphics.print("coming soon I guess maybe not networking is serious shit...",0,0)
	end
end



function enemyUpdates(dt)
	e.wupdate(dt)
	e.canSee()
	eb.update(dt)
end

function worldUpdates(dt)
	world.check()
	wave.spawn(dt)
end

function playerUpdates(dt)
	p.update()
	smoothmove(dt)
end

function bulletUpdates(dt)
	bullet.spawn()
	bullet.update(dt)
end
function killall()
	p.xpos = 32
	p.ypos = 32
	wave.num = 0
	p.score = 0
	bullet.count = 150
	for i,v in ipairs(e) do
		table.remove(e,i)
	end
	for i,v in ipairs(bullet) do
		table.remove(bullet, i)
	end
	for i,v in ipairs(eb) do
		table.remove(eb, i)
	end
	e.wavespawn(5)
end