

p = {}

p.xpos = 32
p.ypos = 32
p.actx = p.xpos - 56
p.acty = p.ypos - 56
p.size = 32
p.health = 100
p.speed = 20
p.score = 0
p.wavescore = 0

bullet = {}
bullet.count = 100

function smoothmove(dt)
	p.actx = p.actx - (p.actx - p.xpos) * p.speed * dt
	p.acty = p.acty - (p.acty - p.ypos) * p.speed * dt
end

function bullet.spawn()
	if love.mouse.isDown("l") then
		if bframe == 0 then
			if bullet.count > 0 then
				x,y = love.mouse.getPosition()
				local mousex = x
				local mousey = y
				local startx = p.xpos + p.size/2
				local starty = p.ypos + p.size/2

				local angle = math.atan2((mousey - starty), (mousex - startx))

				local bulletdx = bulletspeed * math.cos(angle)
				local bulletdy = bulletspeed * math.sin(angle)
				table.insert(bullet, {x = startx, y = starty, dx = bulletdx, dy = bulletdy})
				bullet.count = bullet.count - 1
			end
		end
		bframe = bframe + 1
		if bframe >= 7 then bframe = 0 end
	end
end

function bullet.draw()
	for i,v in ipairs(bullet) do
		love.graphics.setColor(0,255,0)
		love.graphics.circle("line", v.x, v.y, 3)
	end
end 

function bullet.update(dt)
	for i,v in ipairs(bullet) do
		v.x = v.x + (v.dx * dt)
		v.y = v.y + (v.dy * dt)
	end
end

function p.move(k)
	if k == "w" then
		if world.mapcheck(0, -1) then
			p.ypos = p.ypos - 32
		end
	end
	if k == "s" then
		if world.mapcheck(0,1) then
			p.ypos = p.ypos + 32
		end
	end
	if k == "a" then
		if world.mapcheck(-1,0) then
			p.xpos = p.xpos - 32
		end
	end
	if k == "d" then
		if world.mapcheck(1,0) then
			p.xpos = p.xpos + 32
		end
	end
end

function p.update()
	for i,v in ipairs(eb) do
		if CheckCollision(p.xpos,p.ypos,p.size,p.size, v.x,v.y,v.size,v.size) then
			p.health = p.health - 1
		end
	end
	if p.health <= 0 then
		game.state = "over"
		p.health = 100
	end
	if p.health <= 100 then p.health = p.health + .03 end
end

function gameOver()
	local finalscore = (p.score * 100) * wave.num
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setFont(menufont)
	love.graphics.printf("GAME OVER",0,50,screenwidth,"center")
	love.graphics.setFont(font)
	love.graphics.printf("YOU SUCK",0,150,screenwidth,"center")
	--love.graphics.printf("Your score was "..p.score,0,180,screenwidth,"center")
	--love.graphics.printf("You made it to round "..wave.num,0,210,screenwidth,"center")
	love.graphics.printf('Your Final Score Was:  '..finalscore,0,180,screenwidth,"center")
	if love.keyboard.isDown(" ") or love.keyboard.isDown("return") then game.state = "menu";killall() end
end

function p.draw()
	love.graphics.setColor(0,250,154)
	love.graphics.rectangle("fill", p.actx, p.acty, p.size, p.size)
	love.graphics.setColor(255,255,255)
end

function p.drawGUI()
	love.graphics.setColor(255,255,255)
	love.graphics.setFont(font)
	love.graphics.print("Health: ",5,0)
	love.graphics.print("Bullets: "..bullet.count,400,0)
	love.graphics.print("Score :"..p.score, font:getWidth("Wave Number:"..wave.num)+35, love.graphics.getHeight() - font:getHeight())
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",font:getWidth("Health: ") + 7, 32/4 , p.health * 2.7, 32/2 + 5) 
	love.graphics.rectangle("line",font:getWidth("Health: ") + 6, 32/4 -1 , 100 * 2.7 +1 , 32/2 + 6)
end