

world = {
	map = {
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
	}
}
solid = {}
e = {}
e.frame = 0

function setSolid(x,y)
	table.insert(solid, {x=x,y=y,size=32})
end

function setSolids()
	for y=1, #world.map do
		for x=1, #world.map[y] do
			if world.map[y][x] == 1 then
				setSolid((x-1)*32,(y-1)*32)
			end
		end
	end
end

function e.spawn(x,y)
	table.insert(e, {x=x, y=y, health = 7, size = 32,curx=x, cury=y})
end

function e.canSee()
	for i,v in ipairs(e) do
		local diffinx = (p.xpos - v.x) /32
		local diffiny = (p.ypos - v.y) /32
		if math.abs(diffinx) <= 5 and math.abs(diffiny) <= 5 then
			eb.spawn(v.x,v.y)
		end
	end
end

function e.wavespawn(num)
	for i=1,num do
		e.spawn(math.random(3,25)* 32, math.random(3,20) * 32)
	end
end
function world.check()
	--enemy with bullet
	for i,v in ipairs(e) do
		for ii,vv in ipairs(bullet) do
			if CheckCollision(v.x,v.y,v.size,v.size, vv.x,vv.y,3,3) then
				v.health = v.health - 1
				table.remove(bullet, ii)
			end
		end
		if v.health <= 0 then
			table.remove(e, i)
			p.score = p.score + 1
			p.wavescore = p.wavescore + 1
		end
		for ii,vv in ipairs(solid) do
			if CheckCollision(v.x,v.y,32,32, vv.x,vv.y,32,32) then
				v.x = v.curx
				v.y = v.cury
			end
		end
		if v.x <= 32 then v.x = 32 end
		if v.x >= 800-64 then v.x = 800-64 end
		if v.y <= 32 then v.y = 32 end
		if v.y >= 608-64 then v.y = 608-64 end
	end
	--solid with bullets
	for i,v in ipairs(solid) do
		for ii,vv in ipairs(eb) do
			if CheckCollision(v.x,v.y,37,37, vv.x,vv.y,vv.size,vv.size) then
				table.remove(eb, ii)
			end
		end
		for ii,vv in ipairs(bullet) do
			if CheckCollision(v.x,v.y,32,32, vv.x,vv.y,3,3) then
				table.remove(bullet, ii)
			end
		end
	end
end


function e.wupdate(dt)
	if e.frame == 0 then
		e.wander()
	end
	e.frame = e.frame + dt
	if e.frame >= 1 then e.frame = 0 end
end

function e.draw()
	love.graphics.setColor(255,0,0)
	for i,v in ipairs(e) do
		love.graphics.rectangle("fill", v.x, v.y, v.size, v.size)
	end
end

function e.wander()
	for i,v in ipairs(e) do
		v.curx = v.x
		v.cury = v.y
		if v.x < p.xpos then v.x = v.x + 32 end
		if v.x > p.xpos then v.x = v.x - 32 end
		if v.y < p.ypos then v.y = v.y + 32 end
		if v.y > p.ypos then v.y = v.y - 32 end
	end
end

function world.mapcheck(x, y)
	if world.map[((p.ypos + 32)/32 ) + y][((p.xpos+32)/32) + x] == 1 then 
		return false 
	end 
	return true 
end

function world.draw()
	for y=1, #world.map do
		for x=1, #world.map[y] do
			if world.map[y][x] == 1 then
				love.graphics.setColor(50,50,50)
				love.graphics.rectangle("fill",(x-1)*32, (y-1)*32,32,32)
			else
				love.graphics.setColor(150,150,150)
				love.graphics.rectangle("line",(x-1)*32, (y-1)*32,32,32)
			end
		end
	end
end

function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)

  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end